Attribute VB_Name = "Sample"
'===================================================================
' Aisa94s.frm
'-------------------------------------------------------------------
' aISA-S94
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
' Date Jan.1999
'
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
'===================================================================
Option Explicit
Private Const szAisa94 = "aISA-S94"
'===================================================================
' Jn
'===================================================================
Public Sub Main()
    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim wLogSlot As Integer
    Dim ri As AISA94RESOURCE
    Dim wSat As Integer
    Dim wData As Integer

    '---------------------------------------------------------------
    ' Aisa94.DLL J
    '---------------------------------------------------------------
    If False = Aisa94wDllOpen() Then
        ErrorMessage (AISA94_SLOT_AUTO)
        Exit Sub
    End If
    '---------------------------------------------------------------
    ' foCX̎gp錾
    '---------------------------------------------------------------
    wLogSlot = AISA94_SLOT_AUTO '󂫃foCXw
    If False = Aisa94wCreate(wLogSlot) Then
        ErrorMessage (AISA94_SLOT_AUTO)
        Exit Sub
    End If
    strbuf = "aISA-S94 Created" + Chr(10) + Chr(10) + _
             "LogSlot: " + Str(wLogSlot)
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' \[X\
    '---------------------------------------------------------------
    If False = Aisa94wGetResource(wLogSlot, ri) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "Board Name: " + szAisa94 + Chr(10) + _
             "IO Base Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)
    ResultMessage (strbuf)
    
    ''''' gkr^pO '''''
    
    '---------------------------------------------------------------
    ' TeCg
    '---------------------------------------------------------------
    wSat = 3
    strbuf = "TeCg" + Str(wSat) + "ɐݒ肵܂"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' foCX
    '---------------------------------------------------------------
    If Aisa94wInitialize(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("foCX܂")
    '---------------------------------------------------------------
    ' ^p݁i^pJnj
    '---------------------------------------------------------------
    If Aisa94wStart(wLogSlot, wSat) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "^p" + Str(wSat) + "łgkr^pJn܂"
    ResultMessage (strbuf)

    ''''' ^p̏ '''''
    
    '---------------------------------------------------------------
    ' TeCgԍPɑΉ Di GA̓ǂݍ
    '---------------------------------------------------------------
    If Aisa94wDin(wLogSlot, 1, wData) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "TeCg" + Str(1) + "ɑΉDiGA̒l = " + Hex(wData) + "h"
    ResultMessage (strbuf)
    '---------------------------------------------------------------
    ' TeCgԍPɑΉ Do GAɒl
    '---------------------------------------------------------------
    wData = &HAAAA
    If Aisa94wDout(wLogSlot, 1, wData) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    strbuf = "TeCg" + Str(1) + "ɑΉDoGA" + Hex(wData) + "h o͂܂"
    ResultMessage (strbuf)

    ''''' ^p~ '''''
    
    '---------------------------------------------------------------
    ' ^p~
    '---------------------------------------------------------------
    If Aisa94wStop(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("gkr̉^p~܂")
    '---------------------------------------------------------------
    ' foCX
    '---------------------------------------------------------------
    If False = Aisa94wClose(wLogSlot) Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("aISA-S94 Closed")
    '---------------------------------------------------------------
    ' Dll 
    '---------------------------------------------------------------
    If False = Aisa94wDllClose() Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Sub
    End If

End Sub
'===================================================================
' ʂ\
'===================================================================
Private Sub ResultMessage(lpszbuf As String)
    MsgBox lpszbuf, vbOKOnly + vbInformation
End Sub
'===================================================================
' G[bZ[W\
'===================================================================
Private Sub ErrorMessage(wLogSlot As Integer)
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Aisa94wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA94_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-S94 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical
End Sub


