Attribute VB_Name = "Wrapper"
'===================================================================
' Aisa94w.bas
'
' aISA-S94
'
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'===================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA94_DLL_NAME = "Aisa94.dll"         ' DLL
Dim hDLL As Long                                        ' DLLւ̃nh
Global Const AISA94_ERR_WRAPDLL = -1                  ' bp[֐G[

'===================================================================
'       Aisa94.dll [h
'       
' ߂l  True
'        s False
'===================================================================
Function Aisa94wDllOpen() As Boolean
    Aisa94wDllOpen = False
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA94_DLL_NAME)
    If hDLL = 0 Then Exit Function
    If Aisa94wGetDllExportFunc() = False Then
        Aisa94wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    Aisa94wDllOpen = True
End Function
'===================================================================
'       Aisa94.dllA[h
'       
' ߂l  True
'        s False
'===================================================================
Function Aisa94wDllClose() As Boolean
    Aisa94wDllClose = True
    If hDLL = 0 Then Exit Function
    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa94wDllClose = False
End Function
'===================================================================
'    o[Wԍ擾
'    pdwDllVer  DLLo[Wԍi[
'        pdwDrvVer  DRVo[Wԍi[
' ߂l  True
'        s False
'===================================================================
Function Aisa94wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean
    Aisa94wGetVersion = False
    If hDLL = 0 Then Exit Function
    If Aisa94GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
    Aisa94wGetVersion = True
End Function
'===================================================================
'    foCX̎gp錾
'    pwLogSlot gpfoCXi[
' ߂l  True
'        s False
'===================================================================
Function Aisa94wCreate(ByRef pwLogSlot As Integer) As Boolean
    Aisa94wCreate = False
    If hDLL = 0 Then Exit Function
    If Aisa94Create(pwLogSlot) = 0 Then Exit Function
    Aisa94wCreate = True
End Function
'===================================================================
'    foCX̊J
'    wLogSlot   gpfoCX
' ߂l  True
'        s False
'===================================================================
Function Aisa94wClose(ByVal wLogSlot As Integer) As Long
    Aisa94wClose = False
    If hDLL = 0 Then Exit Function
    If Aisa94Close(wLogSlot) = 0 Then Exit Function
    Aisa94wClose = True
End Function
'===================================================================
'    wfoCX̃\[X擾
'    wLogSlot   foCX
'        pres       \[Xi[\
' ߂l  True
'        s False
'===================================================================
Function Aisa94wGetResource(ByVal wLogSlot As Integer, ByRef pres As AISA94RESOURCE) As Boolean
    Aisa94wGetResource = False
    If hDLL = 0 Then Exit Function
    If Aisa94GetResource(wLogSlot, pres) = 0 Then Exit Function
    Aisa94wGetResource = True
End Function
'===================================================================
'    [h
'    wLogSlot   foCX
'        wPort      |[gԍ ( 0,2,4,6 )
'        pwData     ̓f[^i[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Aisa94wInpw(ByVal wLogSlot As Integer, ByVal wPort As Integer, ByRef pwData As Integer) As Boolean
    Aisa94wInpw = False
    If hDLL = 0 Then Exit Function
    If Aisa94Inpw(wLogSlot, wPort, pwData) = 0 Then Exit Function
    Aisa94wInpw = True
End Function
'===================================================================
'    [ho
'    wLogSlot   foCX
'        wPort      |[gԍ ( 0,2,4,6 )
'        wData      o̓f[^
' ߂l  True
'        s False
'===================================================================
Function Aisa94wOutpw(ByVal wLogSlot As Integer, ByVal wPort As Integer, ByVal wData As Integer) As Boolean
    Aisa94wOutpw = False
    If hDLL = 0 Then Exit Function
    If Aisa94Outpw(wLogSlot, wPort, wData) = 0 Then Exit Function
    Aisa94wOutpw = True
End Function
'===================================================================
'    gkrǂݍ
'    wLogSlot   foCX
'        wAdr       AhX
'        pwData     ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Aisa94wMemRead(ByVal wLogSlot As Integer, ByVal wAdr As Integer, ByRef pwData As Integer) As Boolean
    Aisa94wMemRead = False
    If hDLL = 0 Then Exit Function
    If Aisa94MemRead(wLogSlot, wAdr, pwData) = 0 Then Exit Function
    Aisa94wMemRead = True
End Function
'===================================================================
'    gkr
'    wLogSlot   foCX
'        wAdr       AhX
'        wData      ݒl
' ߂l  True
'        s False
'===================================================================
Function Aisa94wMemWrite(ByVal wLogSlot As Integer, ByVal wAdr As Integer, ByVal wData As Integer) As Boolean
    Aisa94wMemWrite = False
    If hDLL = 0 Then Exit Function
    If Aisa94MemWrite(wLogSlot, wAdr, wData) = 0 Then Exit Function
    Aisa94wMemWrite = True
End Function
'===================================================================
'    gkr
'    wLogSlot   foCX
' ߂l  True
'        s False
'===================================================================
Function Aisa94wInitialize(ByVal wLogSlot As Integer) As Boolean
    Aisa94wInitialize = False
    If hDLL = 0 Then Exit Function
    If Aisa94Initialize(wLogSlot) = 0 Then Exit Function
    Aisa94wInitialize = True
End Function
'===================================================================
'    gkrʐMVXeJn
'    wLogSlot   foCX
'        wSNum      ^pTeCg
' ߂l  True
'        s False
'===================================================================
Function Aisa94wStart(ByVal wLogSlot As Integer, ByVal wSNum As Integer) As Boolean
    Aisa94wStart = False
    If hDLL = 0 Then Exit Function
    If Aisa94Start(wLogSlot, wSNum) = 0 Then Exit Function
    Aisa94wStart = True
End Function
'===================================================================
'    gkrʐMVXe~
'    wLogSlot   foCX
' ߂l  True
'        s False
'===================================================================
Function Aisa94wStop(ByVal wLogSlot As Integer) As Boolean
    Aisa94wStop = False
    If hDLL = 0 Then Exit Function
    If Aisa94Stop(wLogSlot) = 0 Then Exit Function
    Aisa94wStop = True
End Function
'===================================================================
'    cGÃAhXɏݎs
'    wLogSlot   foCX
'        wSNo       TeCgm
'        wData      ޒl
' ߂l  True
'        s False
'===================================================================
Function Aisa94wDout(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByVal wData As Integer) As Boolean
    Aisa94wDout = False
    If hDLL = 0 Then Exit Function
    If Aisa94Dout(wLogSlot, wSNo, wData) = 0 Then Exit Function
    Aisa94wDout = True
End Function
'===================================================================
'    cGA̒lǂݍ
'    wLogSlot   foCX
'        wSNo       TeCgm
'        pwData     ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Aisa94wDin(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByRef pwData As Integer) As Boolean
    Aisa94wDin = False
    If hDLL = 0 Then Exit Function
    If Aisa94Din(wLogSlot, wSNo, pwData) = 0 Then Exit Function
    Aisa94wDin = True
End Function
'===================================================================
'    JE^GA̒lǂݍ
'    wLogSlot   foCX
'        wSNo       TeCgm
'        wCntNo     JE^ԍ(1`6)
'        pwData     ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Aisa94wCntRead(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByVal wCntNo As Integer, ByRef pwData As Integer) As Boolean
    Aisa94wCntRead = False
    If hDLL = 0 Then Exit Function
    If Aisa94CntRead(wLogSlot, wCntNo, wSNo, pwData) = 0 Then Exit Function
    Aisa94wCntRead = True
End Function
'===================================================================
'    f[^WX^GA̒lǂݍ
'    wLogSlot   foCX
'        wSNo       TeCgm
'        pwData     ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Aisa94wDRegRead(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByRef pwData As Integer) As Boolean
    Aisa94wDRegRead = False
    If hDLL = 0 Then Exit Function
    If Aisa94DRegRead(wLogSlot, wSNo, pwData) = 0 Then Exit Function
    Aisa94wDRegRead = True
End Function
'===================================================================
'    Rg[GAɃR}h
'    wLogSlot   foCX
'        wSNo       TeCgm
'        wCmd       R}h
' ߂l  True
'        s False
'===================================================================
Function Aisa94wCtrlWrite(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByVal wCmd As Integer) As Boolean
    Aisa94wCtrlWrite = False
    If hDLL = 0 Then Exit Function
    If Aisa94CtrlWrite(wLogSlot, wSNo, wCmd) = 0 Then Exit Function
    Aisa94wCtrlWrite = True
End Function
'===================================================================
'    Rg[GAǂݍ
'    wLogSlot   foCX
'        wSNo       TeCgm
'        pwValue    ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Aisa94wCtrlRead(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByRef pwValue As Integer) As Boolean
    Aisa94wCtrlRead = False
    If hDLL = 0 Then Exit Function
    If Aisa94CtrlRead(wLogSlot, wSNo, pwValue) = 0 Then Exit Function
    Aisa94wCtrlRead = True
End Function
'===================================================================
'    G[R[h擾
'    wLogSlot       foCX
' ߂l  True
'        s False
'===================================================================
Function Aisa94wGetLastError(ByVal wLogSlot As Integer) As Long
    Aisa94wGetLastError = AISA94_ERR_WRAPDLL
    If hDLL = 0 Then Exit Function
    Aisa94wGetLastError = Aisa94GetLastError(wLogSlot)
End Function
'-------------------------------------------------------------------
'    DLLGNX|[g֐AhX̎擾
'    
' ߂l  True
'        s False
'-------------------------------------------------------------------
Private Function Aisa94wGetDllExportFunc() As Boolean
    Dim pFunc As Long

    Aisa94wGetDllExportFunc = False

    pFunc = GetProcAddress(hDLL, "Aisa94GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Create")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Close")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94GetResource")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94GetLastError")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Inpw")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Outpw")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94MemRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94MemWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Initialize")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Start")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Stop")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Dout")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94Din")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94CntRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94DRegRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94CtrlWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Aisa94CtrlRead")
    If pFunc = 0 Then Exit Function


    Aisa94wGetDllExportFunc = True ' SĂ DLL GNX|[g֐݂̑mF

End Function

