/*****************************************************************************/
/*	aisa94w.h																 */
/*																			 */
/*	aISA-S94															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1999/05/26															 */
/*																			 */
/*****************************************************************************/

#ifndef __INC_AISA94W_H__
#define __INC_AISA94W_H__

#include "aisa94.h"


#ifdef __cplusplus
extern "C"{
#endif


#define AISA94_DLL_NAME	  _T("aisa94.dll")	// DLL

#define AISA94_ERR_WRAPDLL ((DWORD)-1)	// bp[֐G[


BOOL  Aisa94wDllOpen();		// DLL [h
BOOL  Aisa94wDllClose();		// DLL A[h

BOOL  Aisa94wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDrvVersion);
BOOL  Aisa94wCreate(PWORD pwLogSlot);
BOOL  Aisa94wClose(WORD wLogSlot);
BOOL  Aisa94wGetResource(WORD wLogSlot, PAISA94R pres);
BOOL  Aisa94wInpw(WORD wLogSlot, WORD wPort, PWORD pwData);
BOOL  Aisa94wOutpw(WORD wLogSlot, WORD wPort, WORD wData);
BOOL  Aisa94wMemRead(WORD wLogSlot, WORD wAdr, PWORD pwData);
BOOL  Aisa94wMemWrite(WORD wLogSlot, WORD wAdr, WORD wData);
BOOL  Aisa94wInitialize(WORD wLogSlot);
BOOL  Aisa94wStart(WORD wLogSlot, WORD wSNum);
BOOL  Aisa94wStop(WORD wLogSlot);
BOOL  Aisa94wDout(WORD wLogSlot, WORD wSNo, WORD wData);
BOOL  Aisa94wDin(WORD wLogSlot, WORD wSNo, PWORD pwData);
BOOL  Aisa94wCntRead(WORD wLogSlot, WORD wSNo, WORD wCntNo, PWORD pwData);
BOOL  Aisa94wDRegRead(WORD wLogSlot, WORD wSNo, PWORD pwData);
BOOL  Aisa94wCtrlWrite(WORD wLogSlot, WORD wSNo, WORD wCmd);
BOOL  Aisa94wCtrlRead(WORD wLogSlot, WORD wSNo, PWORD pwValue);
DWORD Aisa94wGetLastError(WORD wLogSlot);


#ifdef __cplusplus
}
#endif

#endif // __INC_AISA94W_H__
